#ifndef json_main_h
#define json_main_h

#include <queue>
#include <pthread.h>
#include <stdio.h>

#include "octave-json-link.h"
#include "json-util.h"

class json_main {
public:
	json_main(const std::string& json_sock_path);
	~json_main(void);

	void publish_event(const std::string& name, JSON_OBJECT_T jobj);
	void run_loop_on_new_thread(void);
	void run_loop(void);
	void process_json_object(std::string name, JSON_OBJECT_T jobj);

private:
	octave_json_link _octave_json_link;
	int sockfd;
	std::string _json_sock_path;
	pthread_t _loop_thread;
	bool _loop_thread_active;
};

#endif
